using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class CombatSceneManager : MonoBehaviourSingleton
{
		private static CombatSceneManager instance;
		static GameObject player;
//		GameObject enemySpawnLeft;
//		GameObject enemySpawnRight;
		GameObject playerSpawnMiddle;
		GameObject left;
		GameObject right;
		float timeSinceLastHealthDrop;
		float timeSinceLastAmmoDrop;
		float timeSinceLastEnemy;
		float nextEnemySpawn;
		float nextHealthDrop = 10f;
		float nextAmmoDrop = 20f;
		float nextEnemyDrop = 0f;
		static int enemiesKilled;
		static int enemiesSpawned;
		bool isEnded;
		bool isPeace;
		List<EnemyController> enemies = new List<EnemyController> ();
		List<EnemyController> enemiesInfluencedByFlowers = new List<EnemyController> ();

		public static CombatSceneManager getInstance ()
		{
				return instance;
		}

		void Awake ()
		{
				instance = this;
		}
		// Use this for initialization
		void Start ()
		{

				//find spawn points
//				enemySpawnLeft = GameObject.Find ("EnemySpawnLeft");
//				enemySpawnRight = GameObject.Find ("EnemySpawnRight");
				playerSpawnMiddle = GameObject.Find ("PlayerSpawnMiddle");
				left = GameObject.Find ("Left");
				right = GameObject.Find ("Right");

				//spawn player
				player = (GameObject)Instantiate (Resources.Load ("Prefabs/Player"));
				player.transform.position = playerSpawnMiddle.transform.position;
				Camera.main.gameObject.GetComponentInChildren<CameraMovement> ().RegisterTarget (player);

				//example: enemy from the left
//				GameObject enemy = (GameObject)Instantiate (Resources.Load ("Prefabs/EnemyWithGun"));
//				enemy.transform.position = enemySpawnLeft.transform.position;

				//enemy from the right
//				enemy = (GameObject)Instantiate (Resources.Load ("Prefabs/EnemyWithGun"));
//				enemy.transform.position = enemySpawnRight.transform.position;
				
		}
	
		// Update is called once per frame
		void Update ()
		{
				if (!isEnded) {	

						timeSinceLastHealthDrop += Time.deltaTime;
						timeSinceLastAmmoDrop += Time.deltaTime;
						timeSinceLastEnemy += Time.deltaTime;

						if (timeSinceLastHealthDrop >= nextHealthDrop) {
								DropGameObjectAtRandomPosition ("Prefabs/Health");
								timeSinceLastHealthDrop = 0;
								nextHealthDrop = Random.Range (3f, 10f);
						}

						if (timeSinceLastAmmoDrop >= nextAmmoDrop) {
								DropGameObjectAtRandomPosition ("Prefabs/Ammo");
								timeSinceLastAmmoDrop = 0;
								nextAmmoDrop = Random.Range (3f, 10f);
						}

						if (timeSinceLastEnemy >= nextEnemyDrop) {
								GameObject enemyObj = DropGameObjectAtRandomPosition ("Prefabs/EnemyWithGun");
								AddEnemyController (enemyObj.GetComponent<EnemyController> ());
								timeSinceLastEnemy = 0;
								nextEnemyDrop = Random.Range (1f, 3f);
								
						}

						if (IsPeace ()) {
								StatsManager.gameOver.text = "Congratulations!!! You have brought Peace to the world!!!";
								onEnded ();
						}
				}
		}

		bool IsPeace ()
		{
				if (FlowerCollection.GetInstance ().GetNumOfFlowers () > 10) {
			Debug.Log ("Flowers" + FlowerCollection.GetInstance ().GetNumOfFlowers ()+" "+enemiesInfluencedByFlowers.Count );
						if (enemiesInfluencedByFlowers.Count > 20) {
								return true;
						}
				}
				return false;
		}
	
		GameObject DropGameObjectAtRandomPosition (string prefab)
		{
				GameObject theGameObject = (GameObject)Instantiate (Resources.Load (prefab));
				theGameObject.transform.position = getRandomDropPosition ();
				return theGameObject;
		}

		Vector3 getRandomDropPosition ()
		{
				float randomNumber = Random.Range (left.transform.position.x, right.transform.position.x);
				return new Vector3 (randomNumber, -6f, 0);
		}

		public void AddEnemyController (EnemyController enemy)
		{
				this.enemies.Add (enemy);
		}

		public void AddEnemyControllerInfluenced (EnemyController enemy)
		{
				this.enemiesInfluencedByFlowers.Add (enemy);
		}
	
		public void RemoveEnemyController (EnemyController enemy)
		{
				this.enemies.Remove (enemy);
		}

		public static GameObject getPlayer ()
		{
				return player;
		}

		public void onEnded ()
		{
				isEnded = true;
		}
}

