using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class FlowerCollection
{
	
	private static FlowerCollection instance;
	private List<GameObject> flowers;
	
	private FlowerCollection ()
	{
		flowers = new List<GameObject> ();
	}
	
	public static FlowerCollection GetInstance()
	{
		if (instance == null) {
			instance = new FlowerCollection ();
		}
		return instance;
	}

	public void AddFlower(GameObject flower){
		flowers.Add (flower);
	}

	public void RemoveFlowers(int numOfFlowers){
		flowers.RemoveRange (0, numOfFlowers);
	}

	public bool IsInfluencedByFlower(GameObject anObject){
		foreach(GameObject flower in flowers){
			if(Vector3.Distance(flower.transform.position, anObject.transform.position)<10){
				return true;
			}
		}
		return false;
	}

	public int GetNumOfFlowers(){
		return flowers.Count;
	}
}


