﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;

public class PlayerMover : MonoBehaviour {

	// Governs player movement and collision detection

	//public StatsManager statsManager;

	// Parameter für die Spielerbewegung
	private static bool canJumpNow;
	public float speed = 0.5f;
	public float jumpForce = 1000f;

	// 
	private Vector3 moveVec;
	private float nextTime;
	private float moveX;
	private float moveJump;

	//shooting
	Gun gun;
	GunAiming gunAiming;

	Transform spriteTransform;

	void Start(){

		nextTime = 0f;
		canJumpNow = true;

		gun = transform.GetComponentInChildren<Gun> ();
		gun.isEnemyFire = false;
		gunAiming = transform.GetComponentInChildren<GunAiming> ();
		spriteTransform = gameObject.transform.GetChild (0);
	}

	// Update is called once per frame
	void Update () {

		moveX = Input.GetAxisRaw ("Horizontal")*speed;
		moveVec = new Vector3 (transform.position.x+moveX*speed, transform.position.y,0);
		transform.position = moveVec;
		transform.eulerAngles = new Vector3 (0, 0, 0);

		if (Input.GetAxis("Horizontal" ) < 0) {
			gunAiming.AimLeft ();
			if(spriteTransform.localScale.x > 0)
			spriteTransform.localScale = new Vector3(-spriteTransform.localScale.x, 
			                                         spriteTransform.localScale.y, spriteTransform.localScale.z);
		}
		if (Input.GetAxis("Horizontal")>0) {
			gunAiming.AimRight();
			if(spriteTransform.localScale.x < 0)
				spriteTransform.localScale = new Vector3(-spriteTransform.localScale.x, 
				                                         spriteTransform.localScale.y, spriteTransform.localScale.z);
		}

		if (Input.GetKey (KeyCode.Space) && ((canJumpNow) || (nextTime < Time.time))) {

			rigidbody.AddForce(new Vector3(0,jumpForce,0));
			canJumpNow = false;
			nextTime = Time.time + 3f;

		}

		if (Input.GetKey (KeyCode.LeftControl) || Input.GetKeyDown (KeyCode.RightCommand)) {
			gun.FireSalvo(1);
		}

	}

	// Update is called once per frame
	void OnTriggerEnter(Collider other) {
		
		if (other.gameObject.tag == "Ammo") {
		
			StatsManager.pickupAmmo(other);
			
		}

		if (other.gameObject.tag == "Health") {
	
			StatsManager.pickupHealth(other);
			
		}

		if (other.gameObject.tag == "ProjectileEnemy") {

			StatsManager.takeDamage(gameObject);
			SoundManager.playSoundHurt ();
			Destroy(other.gameObject);

		}

		if (other.gameObject.tag == "Ground") {
			
			PlayerMover.enableJump ();
			Debug.Log ("Touch down!");
			
		} 
		
	}

	public static void enableJump() {

		canJumpNow = true;

	}
}
