﻿using UnityEngine;
using System.Collections;

public class SeedFoliage : MonoBehaviour {

	private Vector2 playerPos; 
	private Vector2 mousePos;
	private Vector2 vecDist;
	private float distance;
	private Camera camera;
	private Ray ray;
	private RaycastHit hit;
	private Vector3 hitPoint;

	public float maxDistance;
	public Object flower;

	void Start() {
		camera = GameObject.FindWithTag("MainCamera").GetComponent<Camera>();
	}

	// Update is called once per frame
	void Update () {

		if (StatsManager.getFlowers () > 0) {
			if (Input.GetMouseButtonDown (0)) {
					playerPos = new Vector2 (transform.position.x, transform.position.y);
					mousePos = Input.mousePosition;
					ray = camera.ScreenPointToRay (new Vector3 (mousePos.x, mousePos.y, 0));
					Physics.Raycast (ray, out hit);
					hitPoint = hit.point;

					vecDist = new Vector2 (playerPos.x - hitPoint.x, playerPos.y - hitPoint.y);
					distance = Mathf.Sqrt (vecDist.x * vecDist.x + vecDist.y * vecDist.y);

					if (distance < maxDistance) {

							GameObject flowerObj = (GameObject)Instantiate (flower, new Vector3 (hitPoint.x, hitPoint.y, 0), Quaternion.identity);
							FlowerCollection.GetInstance().AddFlower(flowerObj);
							StatsManager.reduceFlowers();
							Debug.Log ("You have crossed the line!");
					}
			}
		}
	}
}
