﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;

public class StatsManager : MonoBehaviour
{

		// Spieler-Ressourcen
		private static int health;
		private static int ammo;
		private static int flowers;
		private static bool dead;

		// 
		private static int valAmmoPickup;
		private static int valHealthPickup;
		private static int damageValue;
		private static float nextTimeForFlowers; 

		//
		public static Text healthBar;
		public static Text ammoBar;
		public static Text flowerBar;
		public static Text gameOver;
		public static GameObject player;

		//
		public static int winFlowers;
		public static int winKills;

		
		/*
		public GameObject giblet;
		private static GameObject gibObject;
		*/

		void Start ()
		{

				// Display texts
				healthBar = GameObject.FindWithTag ("gui_health").GetComponent<Text> ();
				ammoBar = GameObject.FindWithTag ("gui_ammo").GetComponent<Text> ();
				flowerBar = GameObject.FindWithTag ("gui_flowers").GetComponent<Text> ();
				gameOver = GameObject.FindWithTag ("gui_gameover").GetComponent<Text> ();
				player = GameObject.FindWithTag ("Player");
				gameOver.text = " ";

				// Player states
				health = 100;
				ammo = 100;
				flowers = 0;

				valHealthPickup = 50;
				valAmmoPickup = 50;
				damageValue = 5;
				dead = false;

				displayHealth();
				displayAmmo();
				displayFlowers();

				nextTimeForFlowers = Random.Range (10, 20);
				//Debug.Log("I'm a fully functional StatsManager.");
		
		}

		void Update () {

			if (Time.time > nextTimeForFlowers) {
						flowers++;
						displayFlowers ();
						nextTimeForFlowers = nextTimeForFlowers + Random.Range (5,15);
			}
		}

		public static bool playerIsDead ()
		{

				return dead;

		}

		public static void displayHealth ()
		{

				healthBar.text = "Health: " + health + " ";

		}

		public static void displayAmmo ()
		{

				ammoBar.text = "Ammo: " + ammo + " ";

		}
		

		public static void displayFlowers() 
		{

				flowerBar.text = "Flowers: " + flowers + " ";

		}

		public static int getFlowers() {

				return flowers;

		}

		public static void pickupHealth (Collider other)
		{

			if (health < 100) {

				Destroy (other.gameObject);
				SoundManager.playSoundHealth ();

				if (health >= (100 - valHealthPickup)) {
		
						health = 100;
		
				} else {
		
						health += valHealthPickup;

				}

			}

			displayHealth ();
			Debug.Log (health);

		}

		public static void pickupAmmo (Collider other)
		{
		
				if (ammo < 100) {

						Destroy (other.gameObject);
						SoundManager.playSoundAmmo ();

						if (ammo >= (100 - valAmmoPickup)) {
				
								ammo = 100;
				
						} else {
				
								ammo += valAmmoPickup;

						}

						displayAmmo ();
				}
		
				// Else: nothing happens
		
		}

		public static bool useAmmo ()
		{
				if (ammo > 0) {
						ammo--;
						displayAmmo ();
						return true;
				} else {
						return false;
				}
		}

		public static void takeDamage (GameObject playerObject)
		{

			health -= damageValue;
			displayHealth ();
			if (health <= 0) {

				//Vector3 playerPos = playerObject.transform.position;
//				Destroy (playerObject);

				PlayerMover playerController = playerObject.GetComponentInChildren<PlayerMover>();
				playerController.enabled = false;
				playerObject.transform.eulerAngles = new Vector3(0,0,-90f);
				CombatSceneManager.getInstance().onEnded();
				gameOver.text = "YOU HAVE FAILED!";
				dead = true;
				/* Spawns giblets on player death
				for(int i=0; i<7; i++) {
					gibObject = Instantiate (giblet, playerPos,Quaternion.identity);
					gibObject.rigidbody.AddForce (new Vector3(Random.Range (-5,5),Random.Range (-5,5),5));
				}
				*/
			}
		}

		public static void reduceFlowers() 
		{

			flowers--;
			displayFlowers ();

		}


}
